<?php

/* Sanity check */
if (!file_exists("fortunes.txt")) {
   echo "fatal error, no fortunes.txt found";
   die();
}

/* If a regeneration is needed, do it */
if (!file_exists("cache.inc") ||
    filemtime("cache.inc") < filemtime("fortunes.txt") ||
    filemtime("cache.inc") < filemtime("fortunes.inc"))
{
    $code = "<?php\n";
    $code .= "/* This is a generated page, DO NOT EDIT */\n";
    $c = 0;
    $l = 0;
    $f = "";
    $s = file("fortunes.txt");
    foreach ($s as $i => $line) {
      if($line == "%\n") {
        $c++;
        $l = 0;
      } else {
        $line = ereg_replace('[\]', '\\\\', $line);
        $line = ereg_replace('"', '\\"', $line);
        $line = ereg_replace('\$', '\\$', $line);
        $line = ereg_replace("\n", "", $line);
        $line = ereg_replace("\r", "", $line);
        $code .= '$fortune['.$c.']['.$l.'] = "'.$line.'";'."\n";
        $l++;
      }
    }
    $code .= "?>\n";

    $fd = fopen("cache.inc", "w+");
    fwrite($fd, $code);
    fclose($fd);
}

include("cache.inc");

$count = count($fortune);

function get_karma($n) {
   if (!file_exists("karma/$n")) {
      return array(0,0);
   }

   $karma = 0;
   $f = file("karma/$n");
   /* Enter votes in a hash */
   foreach ($f as $i => $line) {
      $field = split(":",$line,2);
      $s[$field[0]] = substr($field[1],0,2);
   }
   /* Parse the hash so that we get one vote per IP */
   foreach ($s as $i => $vote) {
      if($vote=="-a") {
         $karma -= 2;
      } else if ($vote=="-b") {
         $karma--;
      } else if($vote=="-d") {
         $karma++;
      } else if($vote=="-e") {
         $karma += 2;
      }
   }
   $karma /= sqrt(count($s));
   $karma = round($karma,2);

   return array($karma,count($s));
}

function get_random($n) {
   $best = 0;
   $hiscore = 0;
   for($i=0;$i<3;$i++) {
      $try = rand(1,$n);
      $karma = get_karma(rand(1,$n));
      $score = $karma[0] + 10/(1+$karma[1]);
      if($score>$hiscore) {
         $hiscore = $score;
         $best = $try;
      }
   }

   return $best ? $best : rand(1,$n);
}

?>
